/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	WBTセットアップクラス
//			変更履歴
//				2004.01.08	新規作成	鈴木　敏子
//

package jp.co.ntt.lms.lo.Face2Face;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.*;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.XMODate;
import jp.co.ntt.lms.xmo.LoRelation.LoRelationClient;
import jp.co.ntt.lms.xmo.Assignments.AssignmentsClient;
import jp.co.ntt.lms.xmo.GroupAndPeople.GroupAndPeopleClient;
import jp.co.ntt.lms.xmo.MessageData;
import jp.co.ntt.lms.xmo.XMOException;
import java.sql.SQLException;
import jp.co.ntt.lms.lo.LoLogDataAccess;
import jp.co.ntt.lms.lo.LoLogSessionDataAccess;
import jp.co.ntt.lms.lo.LoLogRecord;
import jp.co.ntt.lms.Common.status.*;
import jp.co.ntt.lms.xmo.Lo.LoClient;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Date;


/**
 * セットアップインタフェースクラス
 *
 * <PRE>
 *   Face2FaceLoの編集(登録・更新・削除・ユーザ登録・ユーザ削除)をする。
 *   上位にセットアップインタフェースクラスを持つ。
 * </PRE>
 *
 */
public class Face2FaceSetup extends Setup
	implements Face2FaceLoPropertyDef
{
	////////////////////////////////////////////////////////////////////////////
	// 抽象メソッドの実装
	////////////////////////////////////////////////////////////////////////////
	/**
	 * セットアップ登録処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 * @exception XMOException
	 */
	protected void setupInsert(Hashtable htbParam)
			throws LOException
	{
		Vector vecRet = new Vector();	//メッセージオブジェクト
		MessageData objMessage = null;

		// パラメータの取得
		String strRealLOID = (String)htbParam.get(LOID);
		String strLOCreateDate = (String)htbParam.get(STUDY_START_DATE);
		Vector vecUserList = (Vector)htbParam.get("UserList");				// アサイン者のリスト

		// パラメータチェック
		if(strRealLOID == null || strRealLOID.equals("")){
			throw new LOException("パラメータが不正です。");
		}

		/*
		 * 【アサイン未済コンテナへの登録処理】
		 * 個別テーブルに登録します。
		 */
		if(vecUserList == null){
			Face2FaceLoDataAccess objFace2Face = new Face2FaceLoDataAccess();
			objFace2Face.insert(htbParam);
		}
		/*
		 * 【アサイン済コンテナへの登録・移動・コピー処理】
		 * 上位LOを割当られているユーザ(学習アサイン)分のLOLogを作成します。(アサイン済コンテナへの登録・移動・コピー処理)
		 */
		else if(vecUserList.size() > 0){
			// 登録項目の設定
			Hashtable htbData = new Hashtable();
			// LOIDの設定
			htbData.put(LOID, strRealLOID);

			try{
				// アサイン者リスト分の共通ログを作成します。
				for(int i=0;i<vecUserList.size();i++){
					// ユーザIDの設定
					htbData.put(USER, vecUserList.get(i));
					// 共通ログの作成
					makeLog( htbData );
				}

			}
			catch( Exception e ) {
				e.printStackTrace();
				throw new LOException( e.getMessage() );
			}
		}

	}

	/**
	 * セットアップ更新処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupUpdate(Hashtable htbParam)
			throws LOException
	{
		Vector vecRet = new Vector();	//メッセージオブジェクト

		Face2FaceLoDataAccess objFace2Face = new Face2FaceLoDataAccess();

		String strLoType = (String)htbParam.get(LO_TYPE);
		//コンテナ変換の場合
		if(strLoType.equals("0")){
			//個別テーブルを削除します
			objFace2Face.delete(htbParam);
		}else{
			//個別テーブル(講師ID)を更新します
			objFace2Face.update(htbParam);
		}
	}

	/**
	 * セットアップ削除処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupDelete(Hashtable htbParam)
			throws LOException
	{
		Vector vecRet = new Vector();	//メッセージオブジェクト

		//個別テーブルを削除します
		Face2FaceLoDataAccess objFace2Face = new Face2FaceLoDataAccess();
		objFace2Face.delete(htbParam);
	}

	/**
	 * セットアップユーザ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupAddUser(Hashtable htbParam)
		throws LOException
	{
	}


	/**
	 * セットアップユーザ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupDelUser(Hashtable htbParam)
		throws LOException
	{
		Vector vecRet = new Vector();	//メッセージオブジェクト
		//個別テーブルを削除します
		Face2FaceLoDataAccess objFace2Face = new Face2FaceLoDataAccess();
		objFace2Face.delete(htbParam);
	}


	/**
	 * セットアップコピー処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupCopy(Hashtable htbParam)
		throws LOException

	{


	}


	/**
	 * 安全にHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strValue, String strKey ) {
		if( strKey != null ) {
			htbData.put( strKey, strValue );
		}
	}


	private void getUserList( String strLOID, String ParentID, String G_ParentID, String strLoCreateDate )
			throws LOException
	{
		MessageData objMessage = null;
		try{
			// 人々ID取得
			if(!ParentID.equals("") && !G_ParentID.equals("")){
				AssignmentsClient objAss = new AssignmentsClient();
				objAss.setWhereMaterialID(G_ParentID + ParentID);
				if(!objAss.select()){
					// 取得エラーをスローする
					throw new XMOException( objAss.getMessageData() );
				}

				while( objAss.next() )
				{
					Hashtable htParam = new Hashtable();
					Vector vecUserList = new Vector();
					String strMemberShipID = objAss.getMemberShipID();					// 人々ID
					String strLernAuthority = objAss.getLearnAuthority();				// 学習権限
					String strManagementAuthority = objAss.getManagementAuthority();	// 管理権限

					// ユーザIDリスト取得
					if(strMemberShipID != null && !strMemberShipID.equals("")){
						GroupAndPeopleClient objGP = new GroupAndPeopleClient();
						objGP.setWhereMemberShipID(strMemberShipID);
						if(!objGP.select()){
							// 取得エラーをスローする
							throw new XMOException( objGP.getMessageData() );
						}

						while( objGP.next() )
						{
							String strChildID = objGP.getChildID();
							if(strChildID.substring(0,2).equals("PE")){
								putData(htParam, strChildID, USER);
								putData(htParam, strLOID, LOID);
								putData(htParam, strLernAuthority, LEARN_AUTHORITY);
								putData(htParam, strManagementAuthority, MANAGEMENT_AUTHORITY);
								putData(htParam, strLoCreateDate, LOCREATEDATE);

								// LOLogを二重登録を防止
								if(vecUserList.indexOf(strChildID) == -1){
									vecUserList.add(strChildID);
									// LoLogを作成します。
									setupAddUser(htParam);
								}
							}
						}
					}
				}
			}
		}catch( Exception e ) {
			throw new LOException( e.getMessage() );
		}
	}
	
	/**
	 * 共通ログを作成します。
	 * @param Hashtable   共通ログ登録項目
	 * @exception LOException
	 * @exception XMOException
	 */
	private void makeLog( Hashtable htbParam  )
			throws LOException
	{
		String strCondition = "";
		// パラメータの取得
		String strRealLOID = (String)htbParam.get(LOID);						// LOID
		String strUserID = (String)htbParam.get(USER);						// ユーザID

		String strLoCreateDate = "";										// 開始日
		String strLastAccess = "";											// 最終アクセス日時
		// システム日付の取得
		String strNow = XMODate.parseTime( new java.util.Date() );

		DataAccess objDataAccess = new DataAccess();
		try{
			// トランザクションの開始
			objDataAccess.trans();

			// LOLogテーブルに存在チェック
			LoLogDataAccess objLoLogDataAccess = new LoLogDataAccess();
			LoLogRecord objLoLogRecord = new LoLogRecord();
			objLoLogRecord = objLoLogDataAccess.getLoLog(strUserID, strRealLOID);
			// LOLogが存在しない場合
			if(objLoLogRecord == null){
				// Logレコードのインスタンスの作成
				objLoLogRecord = new LoLogRecord();

				strLoCreateDate = strNow;
				strLastAccess = strNow;

				// ①LOLogテーブルにデフォルトレコード作成
				Vector vecRet = new Vector();	//メッセージオブジェクト

				//デフォルトの共通ログレコードを登録します。
				objLoLogRecord.setResidanceTime( "0" );					// 累積滞在時間
				objLoLogRecord.setHighScore( "0" );						// 最高点
				objLoLogRecord.setLowScore( "0" );						// 最低点
				objLoLogRecord.setStudyStartDate( strLoCreateDate );	// 開始日
				objLoLogRecord.setStudyEndDate( "" );					// 修了日
				objLoLogRecord.setPassday( "" );						// 合格日
				objLoLogRecord.setExecisePoint( "" );					// 得点
				objLoLogRecord.setFullScore( "" );						// 満点
				objLoLogRecord.setUserID( strUserID );					// ユーザID
				objLoLogRecord.setLoID( strRealLOID );						// LOID
				objLoLogRecord.setAccessCnt( "1" );						// アクセス回数
				objLoLogRecord.setLastAccess( strLastAccess );			// 最終アクセス日時

				// 登録処理
				objLoLogDataAccess.insertUpdate( objLoLogRecord, strUserID, strRealLOID, objDataAccess );

				// 参照LOIDリストを取得します
				LoClient objLoClient = new LoClient();
				if(!objLoClient.getListFromRealLOID( strRealLOID )){
					new LOException("参照LOIDリストの取得失敗しました。");
				}
				String[] strRefList = objLoClient.getRefListResult();
				// 参照リスト分ステータス伝播
				for(int i = 0; i < strRefList.length; i++){
					// ステータス伝搬処理
					StatusPropagation objStatus = new StatusPropagation( strUserID, strRefList[i] );
					PropagateControl.getInstance().addPropagate(objStatus);
				}

				// ②LOLogSessionテーブルにレコード作成
				LoLogSessionDataAccess objSessionDataAccess = new LoLogSessionDataAccess();

				// セッションテーブルの登録レコード生成
				LoLogSessionRecord objSessionData = new LoLogSessionRecord();
				// セッションテーブルのインスタンス化
				objSessionData = new LoLogSessionRecord();
				// セッションレコードにコピー
				objSessionData.setStudyStartDate( strLoCreateDate );	// 開始日
				objSessionData.setResidanceTime( "0" );					// 累積滞在時間
				objSessionData.setPassday( "" );						// 合格日
				objSessionData.setStudyEndDate( "" );					// 修了日
				objSessionData.setHighScore( "0" );						// 最高点
				objSessionData.setLowScore( "0" );						// 最低点
				objSessionData.setExecisePoint( "" );					// 得点
				objSessionData.setFullScore( "" );						// 満点
				objSessionData.setUserID( strUserID );					// ユーザID
				objSessionData.setLoID( strRealLOID );						// LOID
				objSessionData.setSessionID( "1" );			// SessionID

				// セッションテーブル登録処理
				objSessionDataAccess.insert( objSessionData, objDataAccess );

				// コミット
				objDataAccess.commit();

			}
		}
		catch( SQLException se ) {
			se.printStackTrace();
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			// ロールバック
			try { objDataAccess.rollback(); } catch( Exception ex ) {}
			// データベースエラーを設定
			throw new LOException( se.getMessage() );
		}
		catch( Exception e ) {
			e.printStackTrace();
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			// ロールバック
			try { objDataAccess.rollback(); } catch( Exception ex ) {}
			// データベースエラーを設定
			throw new LOException( e.getMessage() );
		}
	}

}

